﻿using SqlSugar;
using System;
using System.ComponentModel.DataAnnotations;

namespace Falcon.SugarApi.DatabaseDefinitions
{
    /// <summary>
    /// 数据表基类。包括字符串类主键和创建时间
    /// </summary>
    public abstract class SugarBasicTable2:EntityStringId
    {
        /// <summary>
        /// 构造数据表基类
        /// </summary>
        public SugarBasicTable2() {
            this.CreateTime = this is IGetDataTimeNow gtn ? gtn.GetDataTimeNow() : DateTime.Now;
        }
        /// <summary>
        /// 创建时间
        /// </summary>
        [Required]
        [SugarColumn(ColumnDescription = "创建时间")]
        public DateTime CreateTime { get; set; } = DateTime.Now;
    }
}
