﻿using SqlSugar;
using System;
using System.Data.Common;
using System.Text;

namespace Falcon.SugarApi.DatabaseManager
{
    /// <summary>
    /// 数据库输出参数值错误
    /// </summary>
    public class DatabaseOutputParameterException:Exception
    {
        /// <summary>
        /// 参数引用
        /// </summary>
        public DbParameter Parameter { get; }

        /// <summary>
        /// 通过参数名和当前值构造错误DbParameter
        /// </summary>
        /// <param name="parameterName">参数名</param>
        /// <param name="parameterValue">参数值</param>
        public DatabaseOutputParameterException(string parameterName,string? parameterValue = null)
            : base("存储过程输出参数返回值错误") {
            this.Parameter = new SugarParameter(parameterName,parameterValue);
        }
        /// <summary>
        /// 通过参数名和当前值构造错误
        /// </summary>
        /// <param name="parameter"></param>
        public DatabaseOutputParameterException(DbParameter parameter)
            : base("存储过程输出参数返回值错误") {
            Parameter = parameter;
        }

        /// <inheritdoc/>
        public override string ToString() {
            var sb = new StringBuilder();
            sb.AppendLine("存储过程输出参数返回值错误!");
            sb.AppendLine($"参数:{this.Parameter.ParameterName}:{this.Parameter.Value}");
            sb.AppendLine(base.ToString());
            return sb.ToString();
        }
    }
}
