﻿namespace Falcon.SugarApi.Swagger
{
    /// <summary>
    /// Swagger配置选项
    /// </summary>
    public class SwaggerOptions
    {
        /// <summary>
        /// 是否启用Swagger
        /// </summary>
        public bool Enable { get; set; } = true;
        /// <summary>
        /// swagger路由前缀
        /// </summary>
        public string Prefix { get; set; } = "";
        /// <summary>
        /// 接口网页标题
        /// </summary>
        public string DocumentTitle { get; set; } = "ApiService Api接口";

        /// <summary>
        /// 是否启用认证
        /// </summary>
        public bool UseAuth { get; set; } = false;
        /// <summary>
        /// 认证用户名
        /// </summary>
        public string? AuthName { get; set; } = "";
        /// <summary>
        /// 认证用户密码
        /// </summary>
        public string? AuthPassword { get; set; } = "";
    }
}
