﻿using Microsoft.Build.Evaluation;
using Microsoft.VisualStudio.TestPlatform.PlatformAbstractions.Interfaces;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.IO.Compression;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace NugetPluginTest
{
    [TestClass]
    public class Test1
    {
        public string BasePath { get => AppDomain.CurrentDomain.BaseDirectory; }
        public string NugetName { get => Path.Combine(BasePath,"Falcon.SugarApi.2.2.0.nupkg"); }

        [TestMethod("nuget包解压测试")]
        public void ExtractNugetTest() {
            var extractPath = Path.Combine(BasePath,"ent");
            if(Directory.Exists(extractPath)) {
                Directory.Delete(extractPath,true);
            }
            Directory.CreateDirectory(extractPath);
            using var packageStream = new FileStream(NugetName,FileMode.Open,FileAccess.Read);
            using var archive = new ZipArchive(packageStream,ZipArchiveMode.Read);
            archive.ExtractToDirectory(extractPath);
            Assert.IsTrue(Directory.GetFiles(extractPath).Length > 0);

        }

        [TestMethod("获取系统运行框架版本")]
        public void GetRuntimeInformation() {
            var info = RuntimeInformation.FrameworkDescription;
            Console.WriteLine(info);
        }

        /// <summary>
        /// 获取项目的Farmwork版本environment.version 
        /// </summary>
        [TestMethod("获取项目运行框架版本")]
        public void GetTargetFramework() {
            try {
                File.Copy("NugetPluginTest.dll","NugetPluginTest.dll1");
                var project = new Project("NugetPluginTest.dll1");
                string targetFramework = project.GetPropertyValue("TargetFramework");

            }
            catch(Exception ex) {
                Console.WriteLine(ex.ToString());
            }
        }

        /// <summary>
        /// 获取项目的Farmwork版本environment.version 
        /// </summary>
        [TestMethod("获取项目运行框架版本 Environment")]
        public void GetTargetFramework2() {
            Console.WriteLine(Environment.Version.ToString());
        }

        /// <summary>
        /// 获取项目的Farmwork版本
        /// </summary>
        [TestMethod("获取项目运行框架版本,条件编译")]
        public void GetTargetFramework1() {

#if NET6
            Console.WriteLine("NET6");
#endif
#if NET6_0
            Console.WriteLine("NET6_0");
#endif
#if NET5_0_OR_GREATER
            Console.WriteLine("NET5_0_OR_GREATER");
#endif
#if NET6_0_OR_GREATER
            Console.WriteLine("NET6_0_OR_GREATER");
#endif
#if NETCOREAPP
            Console.WriteLine("NETCOREAPP");
#endif

        }

    }
}
